<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en-GB">
  <head>
    <title>SO2 Changelog</title>
    <link rel="stylesheet" type="text/css" href="../css/fm.css"/>
  </head>
  
  <body>
    <h1><span>Special Ops 2 Changelog</span></h1>
    <ul id="navbar" class="nl">
      <li><a href="http://specialops.ath.cx/">Special Ops</a></li>
      <li><a href="http://specialops.ath.cx/boards/">SO Boards</a></li>
      <li><a href=".">Documentation Index</a></li>
    </ul>
    
    <p>This is sort of in reverse chronological order.</p>

    <div class="content c0">
      <h2>SO 2.50 - This is SPARTAAAAAAAAAAAAAAAAAAAAAA!!!1</h2>
      <p>Everything has been completely redone in this version. The main highlights are speed improvements, security
         improvements, UI improvements... everything really.</p>
      <p>Most of the speed optimisation in this version was made possible thanks to XDebug [http://xdebug.org].</p>
      <ul>
        <li>Added <var class="file">docs/</var> dir, changelog</li>
        <li>Got rid of the ugly <var class="function">User::has_priv()</var> function and replaced it with a much better
            designed <var class="function">User::has_access()</var>, which also enabled finer-grained board access control.</li>
        <li>Implemented SO1-style userlevels and board access controls</li>
        <li>Rewrote themeing system to allow more fine-grained control of custom CSS, and cleaned up the theme page</li>
        <li>Added a few more HTML form utility classes</li>
        <li>Added a full, correct timezone setting instead of an hour offset - DST works automatically</li>
        <li>Fixed up the HTTP caching slightly</li>
        <li>Moved <var class="function">namelink()</var> and <var class="function">fdate()</var> functions out of
            <var>User</var> and into <var>Page</var> class, which also required making <var class="file">user.php</var>
            partially viewable for anonymous users.</li>
        <li>Replaced per-page username cache with memcache-based one. This has had major side-effects, in particular a bunch of
            SQL query joins used to speed up the old namelink code are now completely unnecessary (and gone!)</li>
        <li>Rewrote the FO3 messagelist display to display quotes only when it makes sense to do so (in the threaded view, this
            is almost never; HTML output is much smaller now).</li>
        <li>Rewrote (message|topic)list paging code, previously it was an appaling mess of nested ternary operators.</li>
        <li>Rewrote options.php with cleaner code and slightly better UI.</li>
        <li>Rewrote <var class="file">stuff.php</var> - stats code many times smaller, text moved into separate XML files in
            <var class="file">res/</var>.</li>
        <li>Moved sensitive data out of <var class="file">con.php</var> into <var class="file">res/config.ini</var></li>
        <li>Removed all mysqli code, now using <var>SO2_PDO</var> class.</li>
        <li>Made a <var>SO2::*</var> container class for stuff that used to use <var>$GLOBALS</var></li>
      </ul>
    </div>

    <div class="content c1">
      <h2>SO 2.14 - This is madness!</h2>
      <p>Beginning of rewriting everything for PDO.</p>
      <p>This one works, but it's half finished and a mess (two DB objects for nothing).</p>
    </div>
  </body>
</html>
